package byu;

/****************************************************************************
** COPYRIGHT (C):    1996 Cay S. Horstmann. All Rights Reserved.
** PROJECT:          Computing Concepts with Java
** FILE:             GraphicsCoord.java
****************************************************************************/

/**
 * An class for mapping user coordinates to screen coordinates
 * @version 1.00 11 Apr 1997
 * @author Cay Horstmann
 * @author Quinn Snell (BYU)
 */

import java.awt.event.*;

class GraphicsCoord
{  static final int INSETS = 2;

   int xwidth;
   int yheight;
   double xleft;
   double xright;
   double ytop;
   double ybottom;
   void setCoord(double x1, double y1, double x2, double y2)
   {  xleft = x1;
	  ytop = y1;
	  xright = x2;
	  ybottom = y2;
   }   
   void setPixel(int w, int h)
   {  xwidth = w;
	  yheight = h;
   }   
   public double xFromPixelPos(int x)
   {  return xleft + (xright - xleft)
		 * (x - INSETS) / (xwidth - 2 * INSETS);
   }   
   public int xToPixelDist(double x)
   {  
	  return (int)Math.round((xwidth - 2 * INSETS) * x / (xright - xleft));
   }   
   public int xToPixelPos(double x)
   {  return INSETS + (int)Math.round((xwidth - 2 * INSETS)
		 * (x - xleft) / (xright - xleft));
   }   
   public double yFromPixelPos(int y)
   {  return ytop + (ybottom - ytop)
		 * (y - INSETS) / (yheight - 2 * INSETS);
   }   
   public int yToPixelDist(double y)
   {
	  return (int)Math.round((yheight - 2 * INSETS) * y / (ytop - ybottom));
   }   
   public int yToPixelPos(double y)
   {  return INSETS + (int)Math.round((yheight - 2 * INSETS)
		 * (y - ytop) / (ybottom - ytop));
   }   
}
