/* 
	Version 1.04 (Jul 00)	:	bug when collapsing sequences to haplotypes fixed (DP)
							:	bug	when calculating outgroup weights for several networks (DP)
					
	Version 1.05 (Jul 00)	:	bug that violated minimum connections fixed (MC)
							:	cosmetic changes (DP)
*/

package clad;
import byu.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import java.io.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;


import EDU.auburn.VGJ.gui.GraphWindow;

import jas.hist.*;
import javax.swing.*;
import jas.hist.*;

public class dna
{
  public int MaxDistance = 5;
  public final int BIGNUM = 1000000000;
  public int debug = 0x8000; //0x9a00; //0x1a00; //0xa00; //0x1c;
  // 1=readfile 2=evaluatemetric 4=printcluster 0x8=connectcomponents 0x10=recalcdist 0x20=buildmatrix
  // 0x40=PrintTaxa 0x80=print metric values for each choice 0x100=recalcmindistance
  // 0x200=connecttaxa 0x400=connectclusters 0x800 print metrics from each choice
  // 0x1000=print cluster connections 0x2000 minimal cluster connection printing.
  // 0x4000=write out intermediate graph files 0x8000 added connections
 
  static JFrame frame;

  public int MinMinDist = 0;
  public Vector components = new Vector();
  public Vector alltaxa = new Vector();
  public Vector realtaxa = new Vector();
  public int maxdistance=40; // The max distance we will pay attention to
  public int maxNameLen = 0; // The max name length, used to build dup shapes

  public static boolean graph_exists;
  public static int num;  // number of sequences
  public static int len;  // lenght of sequences
  public static int[][] distance;                     // pairwise distances among populations
  public static TextInputStream in;	
  public static	boolean lines = false;
  public static	boolean gapmode = true;
  public static boolean distances = false;
  public static boolean printseq = false;
  public static boolean log = true;
  public static	String maxWtaxa[] = new String[100];

  public static TextOutputStream logfile;	

 
/**
 * Insert the method's description here.
 * Creation date: (1/13/00 12:21:23 AM)
 */
public dna() {
//	dprintln("Constructor for dna");

					// Java 1.2
					// Get a PrinterJob
				   // PrinterJob job = PrinterJob.getPrinterJob();
				    // Ask user for page format (e.g., portrait/landscape)
				    //PageFormat pf = job.pageDialog(job.defaultPage());

}
	// derived from a statistical calculation at startup
  
/**
 * add him to all of the distance vectors
 * We only have non-infinite distances if the taxa used to have
 *  a connection to before or after, 
 *   if connected to before it is the distance to before+1
 *   if connected to after it is the distance to after + distance to the other end
 * Otherwise, it is infinite
 *
 * Creation date: (11/4/99 11:42:13 AM)
 * @param ne TaxaItem
 */
public void AddIntermediate(TaxaItem newtaxa, TaxaItem before, int before_distance, TaxaItem after, int after_distance) {
	// newtaxa is the new intermediate
	// before is the taxa before the new intermediate in the chain
	// before_distance is the distance from before to the new intermediate
	// after is the taxa on the other end of this connection
	// after_distance is the distance from the new intermediate to the taxa on the other end of the chain.

	// As we add new taxa, we need to create their distance vectors
	// We also update everyone elses distance vectors to include this node.

	dprintln("adding intermediate " + newtaxa.id + " between " + before.id + "["+before_distance+"]"+ " and " + after.id +"["+after_distance+"]");
	Enumeration enumall;
	TaxaItem curtaxa;
	enumall = alltaxa.elements();
	while (enumall.hasMoreElements()) {
		Distance newdistance, fromnewdistance, dummy;
		
		curtaxa = (TaxaItem) enumall.nextElement();
		
		if(curtaxa == newtaxa) { // If this is the new intermediate, just add the distance object and leave
			fromnewdistance = new Distance(newtaxa.id, curtaxa.id, 0);
			newtaxa.compdist.addElement(fromnewdistance);
			dummy = new Distance(newtaxa.id, curtaxa.id, 0);
			newtaxa.metricdist.addElement(dummy);
			continue;
		}
		// Get the distance between us and the taxa before and the distance between us and the taxa
		// at the other end
		Distance beforetaxa = (Distance) curtaxa.compdist.elementAt(before.id);
		Distance aftertaxa = (Distance) curtaxa.compdist.elementAt(after.id);
		
		// Add a new Distance to all of the distance vectors

		// If there is a current connection to the before taxa that is less than the connection to the after
		if ((beforetaxa.distance != BIGNUM) && (beforetaxa.distance < aftertaxa.distance)) {
			newdistance = new Distance(curtaxa.id, newtaxa.id, beforetaxa.distance + before_distance);
			fromnewdistance = new Distance(newtaxa.id, curtaxa.id, beforetaxa.distance + before_distance);
		} else if (aftertaxa.distance != BIGNUM) {
			newdistance = new Distance(curtaxa.id, newtaxa.id, aftertaxa.distance + after_distance);
			fromnewdistance = new Distance(newtaxa.id, curtaxa.id, aftertaxa.distance + after_distance);
		} else {
			newdistance = new Distance(curtaxa.id, newtaxa.id, BIGNUM);
			fromnewdistance = new Distance(newtaxa.id, curtaxa.id, BIGNUM);
		}
		curtaxa.compdist.addElement(newdistance);
		newtaxa.compdist.addElement(fromnewdistance);
		dummy = new Distance(curtaxa.id, newtaxa.id, BIGNUM);
		curtaxa.metricdist.addElement(dummy);
		dummy = new Distance(newtaxa.id, curtaxa.id, BIGNUM);
		newtaxa.metricdist.addElement(dummy);
		// We shouldnt need to add one to realdist because it only 
		//  deals with real taxa
	}
	printclusters();
}
/**
 * Insert the method's description here.
 * Creation date: (12/15/99 8:35:28 AM)
 */
public void bestMetric(Component sourcec, Component destc, TaxaItem sourcet, TaxaItem destt, int limit) {
	Enumeration enums = sourcec.taxa.elements();
	TaxaItem tempt1, tempt2;
	Enumeration enum2;
	Distance bestDist=new Distance(0,0,0);
	int metric = -BIGNUM;
	while (enums.hasMoreElements()) {
		// If this is the origin taxa, or another intermediate in the cluster, it is a candidate
		tempt1 = (TaxaItem) enums.nextElement();
		if ((tempt1 == sourcet) || tempt1.isIntermediate) {
			enum2 = destc.taxa.elements();
			while (enum2.hasMoreElements()) {
				// If this is the destination taxa, or another intermediate in the cluster, it is a candidate
				tempt2 = (TaxaItem) enum2.nextElement();
				if ((tempt2 == destt) || tempt2.isIntermediate) {

					// Connect the source and destination through these two nodes
					// If the source and destination are in different clusters, we can
					//  treat these existing intermediates as border nodes.  If the two are
					//  in the same cluster, we have to take the distance to the closest one and
					//  treat the closest existing intermediate as the border.
					int total = ((Distance) sourcet.realdist.elementAt(destt.id)).distance;
					dprintln("trying to connect " + sourcet.id + "[" + sourcet.name + "] to " + destt.id + "[" + destt.name + "] through " + tempt1.id + "[" + tempt1.name + "] and " + tempt2.id + "[" + tempt2.name + "]" + "limit=" + limit, 0x200);
					// Evaluate the connection of the components using "total" number of intermediates
					// Recalculate distances, the only ones that will change are the
					//  distances where one item was in tempc1 and the other was in tempc2
					//  The distance for each item is the distance from that item to tempt1
					//   + the distance from tempt1 to tempt2 + the distance from tempt2 to
					//   the item on the other side.  You never need to do a full shortest
					//   path calculation


					// When we are in the same cluster, we can not only add new intermediates,
					//  but we can create a shorter path by directly connecting
					printclusters();
					Distance nearest = ((Distance) sourcet.compdist.elementAt(tempt1.id));
					Distance other = ((Distance) destt.compdist.elementAt(tempt2.id));
					// We dont need to check for distances to the other intermediates (sourcet-tempt2)
					//  since we will check it later.
					// If the distance between the endpoints and the intermediates is already too big,
					//  we dont have a chance
					total -= nearest.distance + other.distance;
					if (total < 1)
						continue;
					dprintln("looking at connection " + tempt1.id + " and " + tempt2.id + " distance " + total, 0x200);
					RecalcDist(sourcec, destc, tempt1, tempt2, total);
					dprintln("after recalcdist " + tempt1.id + " and " + tempt2.id + " distance " + total, 0x200);
					// Evaluate the metric.  You only need to look at pairs distributed
					//  across the two clusters
					int res = EvaluateMetric(sourcec, destc, total, limit);
					dprintln("metric was " + res + " min was " + metric, 0x200);
					if (res > metric) {
						// Unmark previous connections since they are worse than this one
						bestDist.source = tempt1.id;
						bestDist.destination = tempt2.id;
						bestDist.distance = total;
						metric = res;
						dprintln("updating best between "+tempt1.id+" and "+tempt2.id+", metric =" + metric+" total "+total, 0x200);
		
					} else {
						dprintln("Not Keeping this connection min=" + metric + "this configuration=" + res, 0x200);
					}
				}
			}
		}
	}
	tempt1 = (TaxaItem)alltaxa.elementAt(bestDist.source);
	tempt2 = (TaxaItem)alltaxa.elementAt(bestDist.destination);
		
	Distance already = (Distance) tempt1.compdist.elementAt(tempt2.id);
	if (already.distance <= bestDist.distance) {
		dprintln("not adding intermediates between "+tempt1.id+" and "+tempt2.id+", metric =" + metric + " was already " + already.distance + " wanted to make it " + bestDist.distance, 0x8000);
	} else {
		dprintln("adding intermediates between "+tempt1.id+" and "+tempt2.id+", metric =" + metric + " was already " + already.distance + " wanted to make it " + bestDist.distance, 0x8000);
		ConnectComponents(sourcec, destc, bestDist);
	}
	

}
public void BuildMatrix(boolean gapmode) {
	Component tempc1, tempc2; // The two components we are going to compare
	Enumeration enum1 = components.elements();
	TaxaItem tempt1, tempt2; // The two taxa we are going to compare
	Distance mindist = new Distance();
	TaxaItem firsttaxa = (TaxaItem)((Component)components.elementAt(0)).taxa.elementAt(0);
	while (enum1.hasMoreElements()) {
		tempc1 = (Component) enum1.nextElement();
		tempt1 = (TaxaItem) tempc1.taxa.elementAt(0);
		tempc1.mindist.distance = BIGNUM;
		Enumeration enum2 = components.elements();
		mindist.distance = BIGNUM; // mindist will hold the minimum distance from c1 to any c2
		while (enum2.hasMoreElements()) {
			tempc2 = (Component) enum2.nextElement();
			tempt2 = (TaxaItem) tempc2.taxa.elementAt(0);
			Distance realdist = new Distance(tempc1.id, tempc2.id, 0); // tmpdist has the distance between these two
			// If it is myself, add the distance elements and go to top
			if (tempc1.id == tempc2.id) {
				Distance tmpcdist = new Distance(tempc1.id, tempc2.id, 0,
					tempc1,tempc1);
				Distance tmptdist = new Distance(tempt1.id, tempt2.id, 0,
					tempc1,tempc1);
				Distance metricdist = new Distance(tempt1.id, tempt2.id, 0,
					tempc1,tempc1);
				tmpcdist.dc = tempc1;
				tmpcdist.sc = tempc1;
				tmptdist.dc = tempc1;
				tmptdist.sc = tempc1;
				realdist.dc = tempc1;
				realdist.sc = tempc1;
				tempc1.compdist.addElement(tmpcdist);
				tempt1.compdist.addElement(tmptdist);
				tempt1.realdist.addElement(realdist);
				tempt1.metricdist.addElement(metricdist);
				continue;
			}
		
			dprintln(32);
			dprintln("comparing " + tempt1.id + "," + tempt2.id,32);
			for (int k = 0; k < tempt1.characters.length; k++) {
				char char1 = tempt1.characters[k];
				if(char1 == '.')
					char1 = firsttaxa.characters[k];
				char char2 = tempt2.characters[k];
				if(char2 == '.')
					char2 = firsttaxa.characters[k];
				// dprint("[" + tempt1.characters[k] + " " + tempt2.characters[k] + "]");
				if (!gapmode && (char1 == '-' || char2 == '-'))
					continue;
				if (char1 == '?' || char2 == '?' || char1 == 'N' || char2 == 'N')
					continue;
				if (char1 != char2) {
					realdist.distance++;
					dprint("increment to " + realdist.distance + " ",0x20);
				}
			}
			dprintln(0x20);
			Distance tmpcdist = new Distance(tempc1.id, tempc2.id, realdist.distance,
				tempc1,tempc2);
			Distance tmptdist = new Distance(tempt1.id, tempt2.id, BIGNUM,
				tempc1,tempc2);
			Distance metricdist = new Distance(tempt1.id, tempt2.id, BIGNUM,
				tempc1,tempc2);
			tempc1.compdist.addElement(tmpcdist);
			tempt1.compdist.addElement(tmptdist);
			tempt1.realdist.addElement(realdist);
			tempt1.metricdist.addElement(metricdist);
			if (realdist.distance < mindist.distance) {
				mindist.distance = realdist.distance;
				// mindist has taxa ids not component ids
				mindist.source = tempt1.id;
				mindist.sc = tempc1;
				mindist.destination = tempt2.id;
				mindist.dc = tempc2;
				dprintln("min distance for " + tempc1.id + " = " + mindist.distance + " from " + mindist.source + " to " + mindist.destination,0x20);
			}
		}
		dprintln("final min distance for " + tempc1.id + " = " + mindist.distance + " from " + mindist.source + " to " + mindist.destination, 0x20);
		tempc1.mindist.clone(mindist);
		tempt1.minRealDist = mindist.distance;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (1/12/00 10:03:29 PM)
 * @return int
 */
public int buildParseTable(int MaxSequences, int MaxNucleotides) {
	int CutOffDistance;
	int index=0;
	double parsval=1;
	dprintln("\r");
	while (parsval > 0.95) {
		index++;
		parsval = CalcPars(index,MaxNucleotides - index,2000);
		dprintln("For " + index + " step(s), P(95%) = " + parsval);
	}
	dprintln("");

	String a = new String(); a = String.valueOf(index-1);
	GraphWindow.textField.setText(a + " steps");
	GraphWindow.textField.setForeground(Color.blue);
	GraphWindow.textField.update(GraphWindow.textField.getGraphics());

	return(index-1);
}
/**
 * Insert the method's description here.
 * Creation date: (1/12/00 10:35:02 PM)
 * @return double
 * @param j int
 */
public double CalcPars(int j, int m, int it) {
	double i;
	double product;
	double dq, pq;
	double num1, num2, q;
	double int1, int2;
	double t1, tr, tp;
	int b = 3;
	int r = 1;
	double u = 1.0;
	dprintln("j= "+j+" m= "+m+" it= "+it,0x10000);
	product = 1.0;
	dq = u / it;

	/* Product */

	tr = (double) 1.0 / (b * r);
	tp = (double) 2.0 * m + 1.0;
	for (i = 0.00000001; i < j; i += 1.0) {
		/* Integrate */

		int1 = 0.0;
		int2 = 0.0;
		for (q = 0.0000001; q < u; q += dq) {
			t1 = (double) 1.0 - q * tr;
			num2 = Math.pow(q, i) * 
			  Math.pow(((double) 1.0 - q), tp) * t1 * 
			  Math.pow(t1 + 1.0 - q, i) * ((double) 1.0 - 2 * q * t1) * dq;
			num1 = num2 * q;
			int1 += num1;
			int2 += num2;
		}
		pq = (double) 1.0 - int1 / int2;
		product *= pq;
	}
	return (product);
}
/**
 * Connect the clusters to each other
 *  3) Combine the two clusters and recalculate the minimum distances to other clusters
 * Creation date: (10/26/99 2:50:04 PM)
 */
public void CombineClusters(Component tempc1, Component tempc2) {
	TaxaItem tempt1, tempt2;
	Enumeration enum1;
	// Now join the two components into one.

	if(tempc1 == tempc2)
		return;
	enum1 = tempc2.taxa.elements();
	while (enum1.hasMoreElements()) {
		// take the taxa out of the old cluster and put it in the new one
		tempt1 = (TaxaItem)enum1.nextElement();
		tempc1.taxa.addElement(tempt1);
		tempt1.parent = tempc1;
	}
	int removeId = tempc2.id;
	// remove the second component
	components.removeElement(tempc2);
	// Recalculate the min connections
	// For clusters not involved in this collapse, 
	// they need only point to the remaining cluster if the one
	//  they were pointing to was removed.
	// We need to go through all of the taxa in the collapsed cluster to find out what the min connection is
	recalcMinDistance(tempc1, removeId);
}
/**
 * Connect the clusters to each other
 *  1) find the two clusters that are closest
 *  2) insert intermediate nodes in such a way as to preserve the maximum number of distances
 *     between taxa
 *  3) Combine the two clusters and recalculate the minimum distances to other clusters
 * Creation date: (10/26/99 2:50:04 PM)
 */
public int ConnectClusters() {
	TaxaItem tempt1, tempt2;
	Component tempc1, tempc2;
	int i, j;
	Distance mindist = new Distance();
	Distance dist;
	Enumeration enum1, enum2, enumMins;

	// Find the two components that have the minimum distance

	// Look for minimum distance between clusters
	mindist.distance = BIGNUM;
	enum1 = components.elements();
	while (enum1.hasMoreElements()) {
		tempc1 = (Component) enum1.nextElement();
		dprintln("finding min cluster comparing against " + tempc1.mindist.distance + 
			" , current " + mindist.distance,0x400);
		if (tempc1.mindist.distance < mindist.distance) {
			dprintln("updating min cluster to " + tempc1.mindist.distance + " , current was " + mindist.distance,0x400);
			mindist.clone(tempc1.mindist);

		}
	}

	if(mindist.distance > maxdistance) {
		dprintln("Min distance "+mindist.distance+" is greater than maxdistance "+maxdistance+" not connecting");
		return(0);
	}

	// Connect every pair of taxa that are at this min distance.
	
	// Now connect the two real taxa from these two components that have the min distance
	// Delete the second component and copy the other taxa into the first component

	tempc1 = (Component) mindist.sc;
	tempc2 = (Component) mindist.dc;
	enum1 = tempc1.taxa.elements();
	while (enum1.hasMoreElements()) {
		tempt1 = (TaxaItem)enum1.nextElement();
		// If this is a real taxa, not an intermediate
		if (!tempt1.isIntermediate) {
			enum2 = tempc2.taxa.elements();
			while (enum2.hasMoreElements()) {
				tempt2 = (TaxaItem)enum2.nextElement();
				// If this is a real taxa, not an intermediate
				if (!tempt2.isIntermediate) {
					// If this distance is the min distance, add the connection to the list
					Distance thisdist = (Distance) tempt1.realdist.elementAt(tempt2.id);
					if(thisdist.distance == mindist.distance) {
						dprintln("adding two min taxa " + thisdist.source +"["+tempt1.name+"] , " + thisdist.destination+"["+tempt2.name+"]",0x8000);
						dprintln("In clusters " + tempc1.id + " , " + tempc2.id+" distance "+mindist.distance,0x8000);
//if((tempt1.id == 12) && (tempt2.id == 0)) {
//debug = 0x3604;
//printclusters();
//}
						Distance curdist =(Distance)tempt1.compdist.elementAt(tempt2.id);
						if(curdist.distance <= mindist.distance) {
							dprintln("Connection already exists of length "+curdist.distance+" when trying to connect length "+mindist.distance);
							continue;
						}

						bestMetric(tempc1, tempc2, tempt1, tempt2, mindist.distance);
					}
				}
			}
		}
	}

	// Now join the two components into one.
	CombineClusters(tempc1, tempc2);
	return(1);

}
public void ConnectComponents(Component sourcec, Component destc, Distance newdist) {
	Enumeration enumt, enumdestt, addenum;
	TaxaItem sourcet, destt, nextt, newt;

	sourcet = (TaxaItem) alltaxa.elementAt(newdist.source);
	destt = (TaxaItem) alltaxa.elementAt(newdist.destination);
	// Now insert intermediate nodes and make the connections
	dprintln("adding connection" + newdist.source + "[" + sourcet.name + "] , " + newdist.destination + "[" + destt.name + "] distance " + newdist.distance);
	nextt = sourcet;
	int index, intermediates;
	if (newdist.distance == 1) { // No intermediates needed
		sourcet.nbor.addElement(destt);
		destt.nbor.addElement(sourcet);
	} else {
		intermediates = newdist.distance;
		while (intermediates > 1) { // Insert intermediates
			intermediates--;

			// Add intermediate
			newt = new TaxaItem("--", 0, 0);
			// Insert him into the alltaxa vector
			alltaxa.addElement(newt);
			// Insert him into his component
			sourcec.taxa.addElement(newt);
			// find out who the new element is
			index = alltaxa.indexOf(newt);
			newt.id = index;
			newt.isIntermediate = true;
			// Make him my neighbor
			nextt.nbor.addElement(newt);
			newt.nbor.addElement(nextt);

			// add him to all of the distance vectors (in call to AddIntermediate
			// We only have non-infinite distances if the taxa used to have
			//  a connection to nextt or destt, 
			//   if connected to nextt it is the distance to nextt+1
			//   if connected to destt it is the distance to destt+dist.distance
			// Otherwise, it is infinite
			AddIntermediate(newt, nextt, 1, destt, intermediates);

			// Move on to the next intermediate
			nextt = newt;
			if (intermediates == 1) { // This is the last intermediate in the chain
				// Now connect the last intermediate in the chain to the destination
				destt.nbor.addElement(newt);
				newt.nbor.addElement(destt);
			}
		}
	}
	// Now update the compdist fields in the source and destination to reflect the changes
	// Reflect these so that both clusters see them.
	// Sourcet is the current one from the source we are working with,
	// Destt is the current taxa in the destination component where the
	// connection was made.
	// This should probably be optimized later.

	// Iterate over all taxa in the source cluster
	Enumeration senumdist = sourcec.taxa.elements();
	while (senumdist.hasMoreElements()) {
		TaxaItem sourcetdist = (TaxaItem) senumdist.nextElement();
		Distance oldsdist = (Distance) sourcetdist.compdist.elementAt(newdist.source);
		dprintln("recalc source=" + sourcetdist.id, 0x8);
		// If there was some kind of a connection to the border taxa before
		// Update the distance between this node and all others in the opposite cluster

		Enumeration denumdist = destc.taxa.elements();
		// Iterate over all taxa in the destination cluster
		while (denumdist.hasMoreElements()) {
			TaxaItem desttdist = (TaxaItem) denumdist.nextElement();
			int moddist;
			dprintln("recalc dest=" + desttdist.id, 0x8);
			Distance oldddist = (Distance) desttdist.compdist.elementAt(newdist.destination);
			// If there was some kind of a connection to the border taxa before
			// Update the distance between this node and all others in the opposite cluster
			if ((oldsdist.distance == BIGNUM) || (oldddist.distance == BIGNUM)) {
				continue;
			} else {
				Distance changedist = (Distance) sourcetdist.compdist.elementAt(desttdist.id);
				moddist = oldddist.distance + oldsdist.distance + newdist.distance;
				if (moddist < changedist.distance) {
					dprintln("changing distances between " + changedist.source + " and " + changedist.destination + " from " + changedist.distance + " to " + moddist, 0x8);
					changedist.distance = moddist;
				}
				changedist = (Distance) desttdist.compdist.elementAt(sourcetdist.id);
				if (moddist < changedist.distance) {
					dprintln("changing distances between " + changedist.source + " and " + changedist.destination + " from " + changedist.distance + " to " + moddist, 0x8);
					changedist.distance = moddist;
				}
			}
		}
	}
}
/**
 * Connect the source taxa to all other taxa with the minimum distance
 *  1) find the other taxa that are at a minimum distance
 *  2) If a connection doesnt already exist at the min distance, make it
 * Creation date: (10/26/99 2:50:04 PM)
 */
public void ConnectTaxa(TaxaItem source) {
	TaxaItem tempt1, tempt2;
	Component tempc1, tempc2;
	int i, j;
	Distance mindist = new Distance();
	Distance dist;
	Enumeration enum1, enum2;

	// Look for minimum distance between this taxa and all others
	mindist.distance = BIGNUM;
	enum1 = source.realdist.elements();
	while (enum1.hasMoreElements()) {
		dist = (Distance) enum1.nextElement();
		dprintln("finding min other taxa comparing against " + dist.distance + " , current " + mindist.distance,0x200);
		if ((dist.distance < mindist.distance) && (dist.destination != source.id)) {
			dprintln("updating min cluster to " + dist.distance + " , current was " + mindist.distance,0x200);
			mindist.clone(dist);
		}
	}

	if(mindist.distance > maxdistance) {
		dprintln("Min distance "+mindist.distance+" is greater than maxdistance "+maxdistance+" not connecting");
		return;
	}

	// Now add connections to all of the taxa at this min distance
	enum1 = source.realdist.elements();
	while (enum1.hasMoreElements()) {
		dist = (Distance) enum1.nextElement();
		if (mindist.distance == dist.distance) {
			// Add this connection

			TaxaItem sourcet = source;
			TaxaItem destt = (TaxaItem) alltaxa.elementAt(dist.destination);
			dprintln("Add min connection from " + source.id + "[" + source.name + "] to " + dist.destination+"["+destt.name+"] distance "+dist.distance,0x8000);
			// If there is already a connection, do nothing
			Distance already = (Distance) source.compdist.elementAt(dist.destination);
			if (already.distance <= mindist.distance) {
				dprintln("CT We already have a connection between " + source.id + " and " + destt.id + " len " + already.distance + " not adding " + dist.distance,0x200);
				printclusters();
				continue;
			}
			dprintln("two min taxa " + dist.source + "[" + sourcet.name + "] , " + dist.destination + "[" + destt.name + "]",0x200);
// Connect these two in all of the ways that have the best metric
// Add the intermediates before looking at another connection

			tempc1 = (Component) sourcet.parent;
			tempc2 = (Component) destt.parent;
			int limit = sourcet.minRealDist;
			if(limit < destt.minRealDist)
				limit = destt.minRealDist;
				
dprintln("two min dist " + sourcet.minRealDist + "," + destt.minRealDist + "limit " + limit, 0x200);
			bestMetric(tempc1, tempc2, sourcet, destt, limit);

			// Now collapse the clusters
			CombineClusters(tempc1,tempc2);
		}
	}

}
public void dodna(String infile, String outfile, int args, boolean dist)
{
	String matrixfile = null;
	Enumeration enumt;
	TaxaItem source;
	distances = dist;
	int progress = 0;
	float quantum;
	int currentIteration;
	long start1, end1;

	if ((args & 0x1) != 0) {
		gapmode = false;
	}

	if(log)
		logfile = new TextOutputStream("logfile");

	GraphWindow.progressBar.setValue(0);
	GraphWindow.progressBar.update(GraphWindow.progressBar.getGraphics());

	start1 = System.currentTimeMillis();

	// Read the input file
	if(distances)
		ReadDistanceFile(infile);
	else
		ReadInputFile(infile);

	
	if (gapmode)
		dprintln("\rGaps treated as fifth state\r");
	else
		dprintln("\rGaps treated as missing data\r");
	

	if (!distances)	// Build the distance matrix
		BuildMatrix(gapmode);

	// Print the distance matrix
	PrintMatrix(matrixfile);

	quantum = ((float)50)/(float)realtaxa.size();
	currentIteration = 0;
	int middle = 0;


	// Now connect each taxa to the other taxa with minimum distance
	enumt = realtaxa.elements();
	while (enumt.hasMoreElements()) {
		currentIteration++;
		progress = (int) (currentIteration * quantum);
//		dprintln("progress1 = "+progress);

		// Update progress bar
		GraphWindow.progressBar.setValue(progress);
		GraphWindow.progressBar.update(GraphWindow.progressBar.getGraphics());

/*        try {
           Thread.sleep(1000);
        } catch (InterruptedException e) {}
		GraphWindow.p.update(GraphWindow.p.getGraphics());
	
*/		
		source = (TaxaItem) enumt.nextElement();
	  	dprintln("connecting taxa "+source.id+"["+source.name+"]");
	  	printclusters();
//	  	if(source.id == 32)
//	  	  debug = 0xffeb;
	  	ConnectTaxa(source);
		if((debug & 0x4000) != 0) {
			dprintln("writing graph"+middle+".out");
			PrintGraph("graph"+middle+".out");
		}
		middle++;

	}

	quantum = ((float)50)/(float)realtaxa.size();
	currentIteration = 0;

	// Now connect all remaining clusters


	while (components.size() > 1) {
		currentIteration++;
		progress = 50 + (int) (currentIteration * quantum);
//		dprintln("progress2 = "+progress);
		// Update progress bar
		GraphWindow.progressBar.setValue(progress);
		GraphWindow.progressBar.update(GraphWindow.progressBar.getGraphics());

	
		printclusters();
		if((debug & 0x4000) != 0) {
			dprintln("writing graph"+middle+".out");
			PrintGraph("graph"+middle+".out");
		}
		middle++;
		if(ConnectClusters() == 0)
			break;
	}


	// Can we make at least 1 connection ? (i.e., is there a graph?). If not, do not continue
  graph_exists = false;	
  Enumeration enumC = components.elements();
  Enumeration enumT, enumN;
  Component tempC;
  TaxaItem tempT, tempN;

   while(enumC.hasMoreElements()) {
	 tempC = (Component)enumC.nextElement();
     enumT = tempC.taxa.elements();
	 while(enumT.hasMoreElements()) {
	  tempT = (TaxaItem)enumT.nextElement();
  	  enumN = tempT.nbor.elements();
	 if (enumN.hasMoreElements())
		 graph_exists = true;	
   }
}

	if (graph_exists) {
	// Now print out the graph
		OutWeights();	
		dprintln("\rHere is the graph");
		PrintGraph(outfile);
		dprintln("\r\rDone.\r");
	}
	else {
		JOptionPane.showMessageDialog(frame,"No connection below parsimony 95% limit." +
		            "\nA graph cannot be built.",
	                "TCS warning", JOptionPane.ERROR_MESSAGE);		
		frame.dispose();				
		System.exit(0);
	}

	end1 = System.currentTimeMillis();	


	Date time = new Date();	
	dprintln("\r\r" + time.toString());
	dprintln("Datafile = " + infile); 
	dprintln("\rIt took " + (end1-start1)/60000.0 + " minutes.");

	logfile.close();
	
	dprintln("progress2 = "+progress);
	GraphWindow.progressBar.setValue(100);
	GraphWindow.progressBar.update(GraphWindow.progressBar.getGraphics());
	
}

/**
 * Insert the method's description here.
 * Creation date: (11/8/99 9:24:24 AM)
 * @param str java.lang.String
 */
public void dprint(String str) 
{
	if(debug != 0) {
		System.out.print(str);

		if(log)
			logfile.print(str);
	}

}
/**
 * Insert the method's description here.
 * Creation date: (11/8/99 9:24:24 AM)
 * @param str java.lang.String
 */
public void dprint(String str, int level) 
{
	if((debug & level) != 0) {
		System.out.print(str);
		if(log)
			logfile.print(str);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/8/99 9:24:24 AM)
 * @param str java.lang.String
 */
public void dprintln() 
{
	if(debug != 0) {
		System.out.println();
		if(log)
			logfile.println();
	}

}
/**
 * Insert the method's description here.
 * Creation date: (11/8/99 9:24:24 AM)
 * @param str java.lang.String
 */
public void dprintln(int level) 
{
	if((debug & level) != 0) {
		System.out.println();
		if(log)
			logfile.println();
	}
}

/**
 * Insert the method's description here.
 * Creation date: (11/8/99 9:24:24 AM)
 * @param str java.lang.String
 */
public void dprintln(String str) 
{
	if(debug != 0) {
		System.out.println(str);
		if(log)
			logfile.println(str);
	}
	

}
/**
 * Insert the method's description here.
 * Creation date: (11/8/99 9:24:24 AM)
 * @param str java.lang.String
 */
public void dprintln(String str, int level) 
{
	if((debug & level) != 0) {
		System.out.println(str);
		if(log)
			logfile.println(str);
	}

}
/**
 * Evaluate the metric based on the number of correct distances that can be
 *  preserved.  We start with the shortest connection between the two clusters
 *  and move on up, incrementing the metric for every one that works.
 * Creation date: (11/4/99 12:11:04 AM)
 */


public int EvaluateMetric(Component sourcec, Component destc, int numIntermediates, int limit) {

	// Check to see how many work
	// This needs to be optimized, for now we will just search for the minimal
	//  real distance and increment a counter each time one works
	Enumeration enumsourcet, enumdestt, enumdist, realenum;
	TaxaItem sourceitem, destitem;
	Distance mindist = new Distance(0, 0, BIGNUM);
	Distance tmpdist, realdist, metricdist, compdist;
	int counter = 0;
	// The reasoning here is that you really only care that the closest 
	// taxa is correct.  We weight the others on a sliding basis.
	
	final int CORRECT_SCORE = 30; // Add this if the scores match
	final int TOO_SMALL_SCORE = 10; // multiply this by the difference
	final int TOO_BIG_SCORE = 1; // just add this nomatter how much too big it is
	final int NUM_INTERMEDIATE_SCORE = 2; // Add this amount for each intermediate
	final int BAD_GOT_SMALLER = 1000; // Subtract if the distances withing a cluster got smaller
	 // We want this small enough that it will only differentiate between insertions
	 //  that are the same in other ways, but one has more intermediates

	// We have to look at all of the connections within clusters as well as between
	Vector svect = new Vector();
	Vector dvect = new Vector();
	Vector allvect = new Vector();
	
	// Make sure than none of the connections between clusters are 
	// less than the limit, also make sure that the connection doesnt 
	// make any taxa closer than their minimum
	
	dprint(".");
	enumsourcet = sourcec.taxa.elements();
	while (enumsourcet.hasMoreElements()) {
		sourceitem = (TaxaItem) enumsourcet.nextElement();
		svect.addElement(sourceitem);
		allvect.addElement(sourceitem);
//		dvect.addElement(sourceitem);
		
	}
	if(sourcec.id != destc.id) {
		enumdestt = destc.taxa.elements();
		while (enumdestt.hasMoreElements()) {
			destitem = (TaxaItem) enumdestt.nextElement();
//			svect.addElement(destitem);
			dvect.addElement(destitem);
			allvect.addElement(destitem);
		}
	}

	// Go through all of the taxa in the source and dest components
	// Look at all connections that have been made to look for violations
	//, comparing the metricdist with the real dist and count up the number
	// of connections that worked
	counter = -numIntermediates*NUM_INTERMEDIATE_SCORE;
	enumsourcet = svect.elements();
	while (enumsourcet.hasMoreElements()) {
		sourceitem = (TaxaItem) enumsourcet.nextElement();
		if (sourceitem.isIntermediate)
			continue;
		enumdestt = dvect.elements();
		while (enumdestt.hasMoreElements()) {
			destitem = (TaxaItem) enumdestt.nextElement();
			if (destitem.isIntermediate)
				continue;
			if (sourceitem.id == destitem.id)
				continue;
			realdist = (Distance) sourceitem.realdist.elementAt(destitem.id);
			metricdist = (Distance) sourceitem.metricdist.elementAt(destitem.id);
			compdist = (Distance) sourceitem.compdist.elementAt(destitem.id);
			// Dont bother with connections that are too far away
			if((realdist.distance > (2*maxdistance)) && (metricdist.distance > (2*maxdistance)))
				continue;
	
dprintln(" mindistcheck["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" counter "+counter+" limit "+limit+" minsrc "+sourceitem.minRealDist+ " mindest "+destitem.minRealDist  ,0x400);			
			if (realdist.distance == metricdist.distance) {
				counter+=CORRECT_SCORE;
			} else {
				// Dont allow errors that are closer than our mindist
dprintln(" smallcheck["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" counter "+counter+" limit "+limit,0x400);			
				if(realdist.distance > metricdist.distance) {
					if(metricdist.distance <= limit) {

dprintln(" deny1["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" counter "+counter+" limit "+limit,0x400);			
						counter = -BIGNUM;
					} else {
						counter -= TOO_SMALL_SCORE*(realdist.distance - metricdist.distance);
dprintln(" else too small ["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" comp "+compdist.distance+" counter "+counter+" limit "+limit,0x400);			
					}
					
					// Make sure that connections within one of the clusters didnt get worse
					if((compdist.distance < BIGNUM) &&
				   	   (compdist.distance > metricdist.distance)) {
dprintln(" deny2["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" comp "+compdist.distance+" counter "+counter+" limit "+limit,0x400);			
						counter -= BAD_GOT_SMALLER;
				   	}
				} else {
					// Too big
dprintln(" too big["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" comp "+compdist.distance+" counter "+counter+" limit "+limit,0x400);			
					counter -= TOO_BIG_SCORE; //metricdist.distance - realdist.distance;
				}
			}
			dprintln("end ["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" counter "+counter+" limit "+limit,0x400);			
		}	
	}
	// Now check to make sure that no minimum distances have been violated
	enumsourcet = allvect.elements();
	while (enumsourcet.hasMoreElements()) {
		sourceitem = (TaxaItem) enumsourcet.nextElement();
		if (sourceitem.isIntermediate)
			continue;
		enumdestt = allvect.elements();
		while (enumdestt.hasMoreElements()) {
			destitem = (TaxaItem) enumdestt.nextElement();
			if (destitem.isIntermediate)
				continue;
			if (sourceitem.id == destitem.id)
				continue;
			realdist = (Distance) sourceitem.realdist.elementAt(destitem.id);
			metricdist = (Distance) sourceitem.metricdist.elementAt(destitem.id);
			compdist = (Distance) sourceitem.compdist.elementAt(destitem.id);
	
dprintln(" mindistcheck["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" counter "+counter+" limit "+limit+" minsrc "+sourceitem.minRealDist+ " mindest "+destitem.minRealDist  ,0x400);			
			if (metricdist.distance < sourceitem.minRealDist) {
dprintln(" deny3["+realdist.source+","+realdist.destination+"] metric "+metricdist.distance+" real "+realdist.distance+" counter "+counter+" minRealDist "+sourceitem.minRealDist,0x400);			
				counter = -BIGNUM;
				// Dont allow errors that are closer than our mindist
      }
    }
  }
			
	return (counter);
}

/**
 * Insert the method's description here.
 * Creation date: (11/5/99 4:07:13 PM)
 */
public void printclusters() 
{
	TaxaItem tempt1, tempt2;
	Component tempc1, tempc2;
	int i, j;

	Distance dist;
	Enumeration enum1, enum2, enum3;

	if((debug & 0x4) == 0)
		return;
	enum1 = components.elements();
	while (enum1.hasMoreElements()) {
		tempc1 = (Component) enum1.nextElement();
		dprintln();
		dprintln("cluster # " + tempc1.id+" !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		dprintln("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		enum2 = tempc1.taxa.elements();
		while (enum2.hasMoreElements()) {
			tempt1 = (TaxaItem) enum2.nextElement();
			dprintln("Taxa # " + tempt1.id+"["+tempt1.name+"] compdist");
			enum3 = tempt1.compdist.elements();
			while (enum3.hasMoreElements()) {
				dist = (Distance) enum3.nextElement();
				dprint("(["+dist.source+","+dist.destination+"]="+dist.distance+")");
			}
			dprintln();
			dprintln("Taxa # " + tempt1.id+" realdist");
			enum3 = tempt1.realdist.elements();
			while (enum3.hasMoreElements()) {
				dist = (Distance) enum3.nextElement();
				dprint("(["+dist.source+","+dist.destination+"]="+dist.distance+")");
			}
			dprintln();
			dprintln("Taxa # " + tempt1.id+" metricdist");
			enum3 = tempt1.metricdist.elements();
			while (enum3.hasMoreElements()) {
				dist = (Distance) enum3.nextElement();
				dprint("(["+dist.source+","+dist.destination+"]="+dist.distance+")");
			}
			dprintln();
			dprintln("Taxa # " + tempt1.id+"Neighbors");
			enum3 = tempt1.nbor.elements();
			while (enum3.hasMoreElements()) {
				tempt2 = (TaxaItem) enum3.nextElement();
				dprint("("+tempt2.id+"["+tempt2.name+"]),");
			}
			dprintln();

		}
		
		if(tempc1.mindist.dc != null)
		  dprintln("mindist= "+tempc1.mindist.distance+" between "+tempc1.mindist.source+
			" in "+tempc1.id+
			" and " + tempc1.mindist.destination+" in "+tempc1.mindist.dc.id);
	}
}

public void OutWeights()
// calculates outgroup weights for each haplotype per each network
{
	Enumeration enumc = components.elements();
	Enumeration enumn, enumt;
	Component tempc;
	TaxaItem tempt, tempn;
	double total_weight[] = new double[components.size()+1];
	int networkNum = 0;
	 
	while(enumc.hasMoreElements()) {
		tempc = (Component)enumc.nextElement();
		enumt = tempc.taxa.elements();
		networkNum++;
				
		while(enumt.hasMoreElements()) {
			tempt = (TaxaItem)enumt.nextElement();
	   		// Check out this node's neighbors
			if (!tempt.isIntermediate)
			{
				enumn = tempt.nbor.elements();
				int sum_nbor_dup = 0;
				int nnbors = 0;
				int anynbor = 0;
	//			dprintln("\r\rcurrent taxa: " + tempt.name);
				 
				while(enumn.hasMoreElements()) {
					tempn = (TaxaItem)enumn.nextElement();
					if (!tempn.isIntermediate)
					{
						nnbors++;
						sum_nbor_dup += (tempn.numduplicates+1);
					//	dprintln("neighbor: " + tempn.name + " sum_nbor_dup: " + sum_nbor_dup);
					}
					anynbor++;
				}		

				//dprintln("nnbors = " + nnbors);
				
				if (anynbor == 1)
					tempt.isTip = true;
				else
					tempt.isTip = false;
				
				if (tempt.isTip) 
					tempt.weight = (tempt.numduplicates+1)/2.0;
				else 
					tempt.weight = tempt.numduplicates + 1 + sum_nbor_dup;
			
				//dprintln("abs weight = " + tempt.weight);
			
				total_weight[networkNum] += tempt.weight;		
			}
		}
	}

	Enumeration enumcomp = components.elements();
	Enumeration enumnbor, enumtaxa, enumtaxa2;
	Component tempcomp;
	TaxaItem temptaxa, tempnbor;
	double maxW[] = new double[components.size()+1];
	networkNum = 0;	
	maxW[networkNum] = 0.0;
	
	while(enumcomp.hasMoreElements()) {
		tempcomp = (Component)enumcomp.nextElement();
		enumtaxa = tempcomp.taxa.elements();
		networkNum++;
		dprintln("\r*** Network " + networkNum);
		maxW[networkNum] = 0.0;		
		while(enumtaxa.hasMoreElements()) {
			temptaxa = (TaxaItem)enumtaxa.nextElement();

			if (!temptaxa.isIntermediate) {
				temptaxa.oweight = temptaxa.weight/total_weight[networkNum];
				dprintln(temptaxa.name + " weigth = " + temptaxa.oweight);
				
				if (temptaxa.oweight > maxW[networkNum])
				{
					maxW[networkNum] = temptaxa.oweight;
					maxWtaxa[networkNum] = temptaxa.name;
				}
			}
		}
		dprintln("Total weight = " + total_weight[networkNum]);
		dprintln("Biggest outgroup probability is " + maxWtaxa[networkNum] + " (" + maxW[networkNum] + ")");	

	}	
}





public void PrintGraph(String filename)
{
  Enumeration enumc = components.elements();
  Enumeration enumt, enumn, enumd;
  Component tempc;
  TaxaItem tempt, tempn;
  int namesize;
  int networkNum;
  TextOutputStream out = new TextOutputStream(filename);

  out.println("graph [");
  networkNum = 0;	

  // Print out all the nodes and their neighbors
  while(enumc.hasMoreElements()) {
	tempc = (Component)enumc.nextElement();
	enumt = tempc.taxa.elements();
	networkNum++;
	while(enumt.hasMoreElements()) {
    tempt = (TaxaItem)enumt.nextElement();
	if (distances) {
		tempt.numduplicates = 0;
//		maxNameLen = 10;
	}
	  // Print out the node
	  dprint(tempt.name +"["+tempt.id+ "]: ");
	  out.println("node [");
	  out.println("   id " + tempt.id);
//	  out.println("   label \"" + tempt.name + "["+tempt.id+"] \"");
 
	 if(tempt.isIntermediate) {
	  out.println("   label \" \"");
      out.println("   graphics [");
      out.println("   width 6.0");
      out.println("   height 6.0");
      out.println("   depth 1.0");
      out.println("]");
	  out.println("   vgj [");
	  out.println("      labelPosition \"center\"");
	  out.println("   ]");
      } else {
	  out.println("   label \"" + tempt.name + "\"");

	  out.println("   vgj [");
    
      if (tempt.name.equalsIgnoreCase(maxWtaxa[networkNum]))
	  	out.println("   shape  \"rectangle\"");
	
	  out.println("      labelPosition \"center\"");
	  out.println("   ]");

      out.println("   graphics [");

//      out.println("   Image [");
//      out.println("      Type \"URL\"");
//      out.println("      Location \"\"");
//      out.println("   ]");
//      out.println("   center [");
//      out.println("      x 300.0");
//      out.println("      y 56.0");
//      out.println("      z 0.0");
//      out.println("   ]");


			namesize = 9*maxNameLen + tempt.numduplicates*5;
      out.println("   width "+namesize);
			namesize = 20 + tempt.numduplicates*5;
      out.println("   height "+namesize);
      out.println("   depth 20.0");
      out.println("]");
			out.println("   data [");
			out.println("    Frequency \"frequency="+(tempt.numduplicates +1));
			out.println(" " + tempt.name);
			// Print out this taxa duplicates
		  enumd = tempt.dupnames.elements();
		  while(enumd.hasMoreElements()) {
		     String tempd = (String) enumd.nextElement();
		     out.println(" " + tempd);
		  }
			out.println("\"");	
			out.printf("    Weight \"outgroup weight= %6.2f",tempt.oweight);
			out.println("\"");	
			out.println("   ]");

			out.println("   vgj [");
			out.println("      labelPosition \"center\"");
			out.println("   ]");
		}
	  out.println("]");

	  // Print out this nodes neighbors
	  enumn = tempt.nbor.elements();
	  while(enumn.hasMoreElements()) {
		tempn = (TaxaItem)enumn.nextElement();
		// Print out the node name
		System.out.print(tempn.name + "["+tempn.id+"], ");
		out.println("edge [");
		out.println("   source " + tempt.id);
		out.println("   target " + tempn.id);
		out.println("]");
	  }
	  System.out.println();
	}
  }
  out.println("]");
  out.close();
}
public void PrintMatrix(String matrixfile) {
	TextOutputStream out;
	TaxaItem tempt;
	Component tempc1, tempc2;
	Enumeration enum1 = components.elements();
	Distance dist;
//	if (matrixfile != null)
//		out = new TextOutputStream(matrixfile);
//	else
//		out = System.out;
	dprint("pos:      ");
	while (enum1.hasMoreElements()) {
		tempc1 = (Component) enum1.nextElement();
		dprint(" " + tempc1.id + " ");
	}
	dprint("\r");
	enum1 = components.elements();
	while (enum1.hasMoreElements()) {
		tempc1 = (Component) enum1.nextElement();
		Enumeration enum2 = components.elements();
		tempt = (TaxaItem)tempc1.taxa.elementAt(0) ;
		dprint("["+tempt.name+"]");
		dprint(Integer.toString(tempc1.id));
		dprint("  :");
		while (enum2.hasMoreElements()) {
			tempc2 = (Component) enum2.nextElement();
			if (tempc1.id != tempc2.id) {
				dist = (Distance) tempc1.compdist.elementAt(tempc2.id);
				dprint(" " + dist.distance + " ");
			} else {
				dprint(" - ");
			}
		}
		dprint("\r");
	}
}
public void PrintTaxa()
{
  Enumeration enumc = components.elements();
  Enumeration enumt;
  Component tempc;
  TaxaItem tempt;

  while(enumc.hasMoreElements()) {
	tempc = (Component)enumc.nextElement();
	dprintln("tempc id: " + tempc.id,64);
	enumt = tempc.taxa.elements();
	while(enumt.hasMoreElements()) {
	  tempt = (TaxaItem)enumt.nextElement();
	  dprintln("tempt id: " + tempt.id,64);
	  dprintln("Name: " + tempt.name,64);
	  dprintln("Num Duplicates: " + tempt.numduplicates,64);
	  dprintln("Data" + tempt.characters,64);
	}
  }
}


public void ReadInputFile(String infile) {
	in = new TextInputStream(infile);
	char c, ch;
	int j;
	TaxaItem firsttaxa;
	int cnt = 0;
	boolean cr = false;
	boolean lines;
	String name;
	// Check which format do we have, PHYLIP or NEXUS
	String line = in.readLine().toUpperCase();
	
	if (line.startsWith("#NEXUS"))
		ReadNexus();   // NEXUS format SEQUENTIAL
	else
		ReadPhylip(line); // PHYLIP format SEQUENTIAL


	String steps = EDU.auburn.VGJ.gui.GraphWindow.textField.getText();
	
	dprintln("\rSteps string = " + steps + "\r");
	
	if (steps.equals ("Calculate")){
		// Calculate ParsProb and print it
		maxdistance = buildParseTable(num, len);
		dprintln("Calculated maximum connection steps at 95% = " + maxdistance + "\r");
	}
	else {
		maxdistance = Integer.parseInt(steps);
		dprintln("User specified maximum connection steps at 95% = " + maxdistance + "\r");
	}
	
	PrintTaxa();
}

public void ReadNexus() 
{
/*  Reads NEXUS format SEQUENTIAL  */		

	char c, ch;
	int j;
	int cnt = 0;
	boolean cr = false;
	String name = new String();
	dprintln("Data in NEXUS format");

	String token = in.readWord().toUpperCase();
	while(!token.startsWith("NTAX=")) 
		token = in.readWord().toUpperCase();		
	StringTokenizer reader = new StringTokenizer (token," =\n\r\t;");
	reader.nextToken();
	num = Integer.parseInt(reader.nextToken());

	while(!token.startsWith("NCHAR=")) 
		token = in.readWord().toUpperCase();
	reader = new StringTokenizer (token," =\n\r\t;");
	reader.nextToken();
	len = Integer.parseInt(reader.nextToken());
		
	dprintln("Number of sequences: " + num);
	dprintln("Length of sequences: " + len);
	
	while(!token.equals("MATRIX")) // go all the way to the sequences
		token = in.readWord().toUpperCase();

   // get rid of potential stuff after the "Matrix" word and before sequence name
	c = in.readChar();
	while (c == '\r' || c == '\n' || c == '\t') {
		c = in.readChar();
		lines = true;
	}
	// if there is a comment for the position numbers (e.g McClade) [ 1 2 3 4] after "Matrix"		
	if (c  == '[')
			while ((c = in.readChar()) != ']'); 
	// in case there are more things in the way to the sequences
	while (c == '\r' || c == '\n' || c == '\t' || c == ']' || c == ' ') 
	{
		c = in.readChar();
		lines = true;
		dprintln(c);	
	}

	for (int i = 0; i < num; i++) {
		
		name = in.readWord();
		
		if (lines) // we have stolen the first character of the fist name. Let's get it back
		{
			String nname = new String();
			nname = nname.valueOf(c);
			nname = nname.concat(name);
			name = nname;
			lines = false;
		}

		if (printseq)
			dprintln("\r" + (i+1) + ". " + name);
			
		TaxaItem temptaxa = new TaxaItem(name, len, cnt);
		temptaxa.isIntermediate = false;

		if (name.length() == 0)
			name = in.readLine();
		if(maxNameLen < name.length())
			maxNameLen = name.length();
		temptaxa.name = name;

		for (j = 0; j < len; j++) {

			// skip white spaces between name and beginning of sequence
			while ((c = in.readChar()) == ' '); 
					
			temptaxa.characters[j] = c;	

			if (printseq)
				System.err.print(c);

	 		if (c == '\n' || c == '\r'){
				JOptionPane.showMessageDialog(frame,"You have extra returns in sequence \"" + name + "\".",
			                "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}

	 		if (c == ' '){
				JOptionPane.showMessageDialog(frame,"The lenght of sequence \"" +  name + "\""+ " is not " + len + ".",
			                "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}

	 		if (c != 'A' && c != 'C' && c != 'G' && c != 'T' && c!= '-' && c != '.' &&
	 		    c != 'a' && c != 'c' && c != 'g' && c != 't' && c != 'N' && c != '?'){
				JOptionPane.showMessageDialog(frame,"One of the characters in sequence \"" + name + "\" is not (ACGCacgt.?N-).",
				 "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}

	 		if (in.EOF()){
				JOptionPane.showMessageDialog(frame,"Unexpected end of file was encountered.",
			                "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}
		}

		dprintln("Read data: " + temptaxa.characters,1);
		in.readLine(); // get rid of the CR


		TaxaItem firsttaxa;
		int numdups = 0;
		char newc, oldc;
		Enumeration enumc = components.elements();
		Component tempc;
		while (enumc.hasMoreElements()) {
			firsttaxa = (TaxaItem)((Component)components.elementAt(0)).taxa.elementAt(0);
			tempc = (Component) enumc.nextElement();
			dprintln("looking at component: " + tempc.id,1);
			boolean dup = true;
			TaxaItem tempt;
			tempt = (TaxaItem) tempc.taxa.elementAt(0); // There should be exactly one here
			dprintln("looking at taxa: " + tempt.id+" named " + tempt.name+
				"and" +temptaxa.id+" named "+temptaxa.name,1);
			dprintln("comparing "+tempt.characters,1);
			dprintln("with "+temptaxa.characters,1);

			for (int k = 0; k < len; k++) {
				newc = temptaxa.characters[k];
				oldc = tempt.characters[k];
				if(newc == '.')
					newc = firsttaxa.characters[k];
				if(oldc == '.')
					oldc = firsttaxa.characters[k];
				dprint("[" + newc + "," + oldc + "]",1);
				if (!gapmode && (newc == '-' || oldc == '-'))
					continue;
				if (newc == '?' || oldc == '?' || newc == 'N' || oldc == 'N')
					continue;
				if (newc != oldc) {
					dup = false;
					break;
				}
			}
			dprintln(1);
			if (dup == true) {
				tempt.numduplicates++;
				numdups++;
				tempt.dupnames.addElement(temptaxa.name);
				dprintln("duplicate name: " + name + " duplicates " + tempt.numduplicates,1);
				break;
			}
		}
		if (numdups == 0) { // Add this to the component Vector
			tempc = new Component(cnt);
			tempc.taxa.addElement(temptaxa);
			temptaxa.parent = tempc;
			alltaxa.addElement(temptaxa);
			realtaxa.addElement(temptaxa);
			cnt++;
			components.addElement(tempc);
			dprintln("Added name: " + name,1);
		}
	}
}





public void ReadPhylip (String line) 
{	
/* Reads PHYLIP format SEQUENTIAL (max lenght of the names = 10) */	 	

	char c, ch;
	int j;
	TaxaItem firsttaxa;
	int cnt = 0;
	boolean cr = false;

	dprintln("\nData in PHYLIP format");

	StringTokenizer reader = new StringTokenizer (line);
	
	num = Integer.parseInt(reader.nextToken());
	len= Integer.parseInt(reader.nextToken());

	dprintln("Number of sequences: " + num);
	dprintln("Length of sequences: " + len);

	// Add the components
	for (int i = 0; i < num; i++) {
		StringBuffer label = new StringBuffer();

		for (int k = 0; k < 10; k++) {
			ch = in.readChar();
			if (ch == '\n' || ch == '\r')
			{
				cr = true;
				break;
			}
			label.append(ch);
		}
		
		String name = label.toString();

		if (printseq)
			dprintln("\r" + (i+1) + ". " + name);
	
		TaxaItem temptaxa = new TaxaItem(name, len, cnt);

		temptaxa.isIntermediate = false;
		if (name.length() == 0)
			name = in.readLine();
		if(maxNameLen < name.length())
			maxNameLen = name.length();
		temptaxa.name = name;

		for (j = 0; j < len; j++) {
			c = in.readChar();
			if (c == '\n' || c == '\r') // there is a CR after the name
				c = in.readChar();
			temptaxa.characters[j] = c;	
	
			if (printseq)
				System.err.print(c);

	 		if (c == '\n' || c == '\r'){
				JOptionPane.showMessageDialog(frame,"You have extra returns in sequence \"" + name + "\".",
			                "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}

	 		if (c == ' '){
				JOptionPane.showMessageDialog(frame,"The lenght of sequence \"" +  name + "\""+ " is not " + len + ".",
			                "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}

	 		if (c != 'A' && c != 'C' && c != 'G' && c != 'T' && c!= '-' && c != '.' &&
	 		    c != 'a' && c != 'c' && c != 'g' && c != 't' && c != 'N' && c != '?'){
				JOptionPane.showMessageDialog(frame,"One of the characters in sequence \"" + name + "\" is not (ACGCacgt.?N-).",
				 "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}

	 		if (in.EOF()){
				JOptionPane.showMessageDialog(frame,"Unexpected end of file was encountered.",
			                "TCS warning", JOptionPane.WARNING_MESSAGE);		
				frame.dispose();				
				System.exit(0);
			}
		}

		dprintln("Read data: " + temptaxa.characters,1);
		in.readLine(); // get rid of the CR


		int numdups = 0;
		char newc, oldc;
		Enumeration enumc = components.elements();
		Component tempc;
		while (enumc.hasMoreElements()) {
			firsttaxa = (TaxaItem)((Component)components.elementAt(0)).taxa.elementAt(0);
			tempc = (Component) enumc.nextElement();
			dprintln("looking at component: " + tempc.id,1);
			boolean dup = true;
			TaxaItem tempt;
			tempt = (TaxaItem) tempc.taxa.elementAt(0); // There should be exactly one here
			dprintln("looking at taxa: " + tempt.id+" named " + tempt.name+
				"and" +temptaxa.id+" named "+temptaxa.name,1);
			dprintln("comparing "+tempt.characters,1);
			dprintln("with "+temptaxa.characters,1);

			for (int k = 0; k < len; k++) {
				newc = temptaxa.characters[k];
				oldc = tempt.characters[k];
				if(newc == '.')
					newc = firsttaxa.characters[k];
				if(oldc == '.')
					oldc = firsttaxa.characters[k];
				dprint("[" + newc + "," + oldc + "]",1);
				if (!gapmode && (newc == '-' || oldc == '-'))
					continue;
				if (newc == '?' || oldc == '?' || newc == 'N' || oldc == 'N')
					continue;
				if (newc != oldc) {
					dup = false;
					break;
				}
			}
			dprintln(1);
			if (dup == true) {
				tempt.numduplicates++;
				numdups++;
				tempt.dupnames.addElement(temptaxa.name);
				dprintln("duplicate name: " + name + " duplicates " + tempt.numduplicates,1);
				break;
			}
		}

		if (numdups == 0) { // Add this to the component Vector
			tempc = new Component(cnt);
			tempc.taxa.addElement(temptaxa);
			temptaxa.parent = tempc;
			alltaxa.addElement(temptaxa);
			realtaxa.addElement(temptaxa);
//			alltaxa.add(temptaxa.id, temptaxa);
//			realtaxa.add(temptaxa.id, temptaxa);
			cnt++;
			components.addElement(tempc);
			dprintln("Added name: " + name,1);
		}
	}
}


public void ReadDistanceFile (String infile)
{
	char c, ch;
	//TaxaItem firsttaxa;
	int cnt = 0;
	boolean cr = false;
	in = new TextInputStream(infile);

	String line = in.readLine().toUpperCase();
	if (line.startsWith("#NEXUS"))
		ReadNexusDis();   // Distances in NEXUS format, lower matrix
	else
		ReadPhylipDis(line); // Distances in PHYLIP format, lower matrix
	// Calculate ParsProb and print it
	maxdistance = buildParseTable(num, len);
	dprintln("Maximum connection steps at 95% = " + maxdistance + "\r");
	PrintTaxa();
}

public void ReadNexusDis() {
	char c, ch;
	String name = new String();
	Frame frame = new Frame();
	dprintln("\rReading NEXUS distance file\r");

	String token = in.readWord().toUpperCase();
	while(!token.startsWith("NTAX=")) 
		token = in.readWord().toUpperCase();		
	StringTokenizer reader = new StringTokenizer (token," =\n\r\t;");
	reader.nextToken();
	num = Integer.parseInt(reader.nextToken());


	while(!token.startsWith("NCHAR=")) 
		token = in.readWord().toUpperCase();
	reader = new StringTokenizer (token," =\n\r\t;");
	reader.nextToken();
	len = Integer.parseInt(reader.nextToken());

	if (Character.isDigit((char)num)){
		JOptionPane.showMessageDialog(frame,"Problems reading the number of the sequences!",
		 "TCS warning", JOptionPane.WARNING_MESSAGE);		
		frame.dispose();				
		System.exit(0);
	}

	if (Character.isDigit((char)len)){
		JOptionPane.showMessageDialog(frame,"Problems reading the length of the sequences!",
		 "TCS warning", JOptionPane.WARNING_MESSAGE);		
		frame.dispose();				
		System.exit(0);
	}

	dprintln("Number of sequences: " + num);
	dprintln("Length of sequences: " + len);
	
	while(!token.equals("MATRIX")) // go all the way to the distances
		token = in.readWord().toUpperCase();

   // get rid of potential stuff after the "Matrix" word and before sequence name
	c = in.readChar();
	while (c == '\r' || c == '\n' || c == '\t') {
		c = in.readChar();
		lines = true;
	}
	// if there is a comment for the position numbers (e.g McClade) [ 1 2 3 4] after "Matrix"		
	if (c  == '[')
			while ((c = in.readChar()) != ']'); 
	// in case there are more things in the way to the sequences
	while (c == '\r' || c == '\n' || c == '\t' || c == ']' || c == ' ') 
	{
		c = in.readChar();
		lines = true;
		dprintln(c);	
	}	

	ReadMatrix(c);

}

public void ReadPhylipDis (String line) {
	dprintln("\rReading PHYLIP distance file\r");
	StringTokenizer reader = new StringTokenizer (line);
	Frame frame = new Frame();
	num = Integer.parseInt(reader.nextToken());
	len= Integer.parseInt(reader.nextToken());

	if (Character.isDigit((char)num)){
		JOptionPane.showMessageDialog(frame,"Problems reading the number of the sequences!",
		 "TCS warning", JOptionPane.WARNING_MESSAGE);		
		frame.dispose();				
		System.exit(0);
	}

	if (Character.isDigit((char)len)){
		JOptionPane.showMessageDialog(frame,"Problems reading the length of the sequences!",
		 "TCS warning", JOptionPane.WARNING_MESSAGE);		
		frame.dispose();				
		System.exit(0);
	}

	dprintln("Number of sequences: " + num);
	dprintln("Length of sequences: " + len);

	ReadMatrix('a');
}


public void ReadMatrix (char c) {	
/* Reads a matrix of distances in lower diagonal format */
	Frame frame = new Frame();
	int popA, popB;
	String[] names = new String [num];
	String nname = new String();
	distance = new int[num][num];
	maxNameLen = 0;

	for (popA=0; popA<num; popA++)
	{
		names[popA] = in.readWord();

		if (lines) // we have stolen the first character of the fist name. Let's get it back
		{
			nname = nname.valueOf(c);
			nname = nname.concat(names[0]);
			names[0] = nname;
			lines = false;
		}

		System.err.print("\r" + names[popA] + "  ");
	
		if (names[popA] == null)
		{
			JOptionPane.showMessageDialog(frame,"There was an error reading the sequence names" +
			"\nin the pairwise distance matrix",
                        "TCS warning", JOptionPane.WARNING_MESSAGE);

			frame.dispose();				
			System.exit(0);
		}

		if(maxNameLen < names[popA].length())
			maxNameLen = names[popA].length();
		
		for (popB=0; popB<popA; popB++) 
		{
			distance[popA][popB] = distance[popB][popA] = in.readInt();
			
			if (distance[popA][popB] < 1)
			{
				JOptionPane.showMessageDialog(frame,"There was an error reading the distance matrix." +
				             "\nAre you using absolute distances ?" +
				             "\nAre you inputing HAPLOTYPE distances (no zeroes in the matrix)?",
                            "TCS warning", JOptionPane.WARNING_MESSAGE);

				frame.dispose();				
				System.exit(0);
			}
   			System.err.print(" " + distance[popA][popB]);
   		}
	}
	// Now convert the matrix to the vectors used in the rest of the program
	
	Component tempc;
	TaxaItem temptaxa;
	int cnt;

	for(cnt = 0; cnt < num; cnt++) {
		tempc = new Component(cnt);
		components.addElement(tempc);
		temptaxa = new TaxaItem(names[cnt], len, cnt);
		temptaxa.isIntermediate = false;
		tempc.taxa.addElement(temptaxa);
		temptaxa.parent = tempc;
		alltaxa.addElement(temptaxa);
		realtaxa.addElement(temptaxa);
	}
	Component tempc1, tempc2;
	TaxaItem tempt1, tempt2;
	Enumeration enum1 = components.elements();
	Distance mindist = new Distance();
	TaxaItem firsttaxa = (TaxaItem)((Component)components.elementAt(0)).taxa.elementAt(0);
	while (enum1.hasMoreElements()) {
		tempc1 = (Component) enum1.nextElement();
		tempt1 = (TaxaItem) tempc1.taxa.elementAt(0);
		tempc1.mindist.distance = BIGNUM;
		Enumeration enum2 = components.elements();
		mindist.distance = BIGNUM; // mindist will hold the minimum distance from c1 to any c2
		while (enum2.hasMoreElements()) {
			tempc2 = (Component) enum2.nextElement();
			tempt2 = (TaxaItem) tempc2.taxa.elementAt(0);
			Distance realdist = new Distance(tempc1.id, tempc2.id, 0); // tmpdist has the distance between these two
			// If it is myself, add the distance elements and go to top
			if (tempc1.id == tempc2.id) {
				Distance tmpcdist = new Distance(tempc1.id, tempc2.id, 0,
					tempc1,tempc1);
				Distance tmptdist = new Distance(tempt1.id, tempt2.id, 0,
					tempc1,tempc1);
				Distance metricdist = new Distance(tempt1.id, tempt2.id, 0,
					tempc1,tempc1);
				tmpcdist.dc = tempc1;
				tmpcdist.sc = tempc1;
				tmptdist.dc = tempc1;
				tmptdist.sc = tempc1;
				realdist.dc = tempc1;
				realdist.sc = tempc1;
				tempc1.compdist.addElement(tmpcdist);
				tempt1.compdist.addElement(tmptdist);
				tempt1.realdist.addElement(realdist);
				tempt1.metricdist.addElement(metricdist);
				continue;
			}
		
			realdist.distance = distance[tempc1.id][tempc2.id];
			
			Distance tmpcdist = new Distance(tempc1.id, tempc2.id, realdist.distance,
				tempc1,tempc2);
			Distance tmptdist = new Distance(tempt1.id, tempt2.id, BIGNUM,
				tempc1,tempc2);
			Distance metricdist = new Distance(tempt1.id, tempt2.id, BIGNUM,
				tempc1,tempc2);
			tempc1.compdist.addElement(tmpcdist);
			tempt1.compdist.addElement(tmptdist);
			tempt1.realdist.addElement(realdist);
			tempt1.metricdist.addElement(metricdist);
			if (realdist.distance < mindist.distance) {
				mindist.distance = realdist.distance;
				// mindist has taxa ids not component ids
				mindist.source = tempt1.id;
				mindist.sc = tempc1;
				mindist.destination = tempt2.id;
				mindist.dc = tempc2;
				dprintln("min distance for " + tempc1.id + " = " + mindist.distance + " from " + mindist.source + " to " + mindist.destination,0x20);
			}
		}
		dprintln("final min distance for " + tempc1.id + " = " + mindist.distance + " from " + mindist.source + " to " + mindist.destination, 0x20);
		tempc1.mindist.clone(mindist);
		tempt1.minRealDist = mindist.distance;
	}
} 




/**
 * Recalculate the metric distances between clusters sourcec and destc 
 *  when a connection of "length" is made between taxa "sourcet" and "destt"
 * We dont actually add the intermediates.  Just put the specified length in
 *  the distance field for the metric and recalculate distances between
 *  clusters.
 * Creation date: (11/3/99 11:33:00 PM)
 * @param sourcec Component
 * @param destc Component
 * @param sourcet TaxaItem
 * @param destt TaxaItem
 * @param length int
 */
public void RecalcDist(Component sourcec, Component destc, TaxaItem sourcebordert, TaxaItem destbordert, int length) {
	// sourcec is the source component
	// destc is the destination component
	// sourcebordert is the taxa on the border that we are going to connect to a taxa in the dest cluster
	// destbordert is the taxa on the border that we are going to connect to a taxa in the source cluster
	// First set the distance between sourcet and destt
	// length is the distance between the two border taxa
	Distance sd = (Distance) sourcebordert.metricdist.elementAt(destbordert.id);
	sd.distance = length;
	// We need to update distances within the clusters that might have changed as well
	// So we create two vectors with all of the taxa from both clusters in them.
	Vector svect = new Vector();
	Vector dvect = new Vector();
	Enumeration enumsourcet, enumdestt;
	TaxaItem sourceitem, destitem;
	
	enumsourcet = sourcec.taxa.elements();
	while (enumsourcet.hasMoreElements()) {
		sourceitem = (TaxaItem) enumsourcet.nextElement();
		svect.addElement(sourceitem);
		dvect.addElement(sourceitem);
		
	}
	if(sourcec.id != destc.id) {
		enumdestt = destc.taxa.elements();
		while (enumdestt.hasMoreElements()) {
			destitem = (TaxaItem) enumdestt.nextElement();
			svect.addElement(destitem);
			dvect.addElement(destitem);
		}
	}

	// Now update all of the distances

	Distance dist, compdist;
	int newdistance;
	enumsourcet = svect.elements();
	while (enumsourcet.hasMoreElements()) {
		sourceitem = (TaxaItem) enumsourcet.nextElement();
		enumdestt = dvect.elements();
		while (enumdestt.hasMoreElements()) {
			destitem = (TaxaItem) enumdestt.nextElement();
			dprintln("RCD sourcec " + sourcec.id + " destc " + destc.id + "sourceborder" + sourcebordert.id + " destborder " + destbordert.id + " length " + length, 16);

			// set distance = dist(here->border) + dist(border->border-on-other-cluster) +
			//  dist(border-on-other-cluster->other taxa)
			dist = (Distance) sourceitem.metricdist.elementAt(destitem.id);
			compdist = (Distance) sourceitem.compdist.elementAt(destitem.id);
			newdistance = ((Distance) sourceitem.compdist.elementAt(sourcebordert.id)).distance; // source to border
			dprintln("distance from " + dist.source + " to " + dist.destination + " = " + newdistance, 16);
			
			newdistance += length;
			dprintln("distance from " + dist.source + " to " + dist.destination + " = " + newdistance, 16);
			newdistance += ((Distance) destbordert.compdist.elementAt(destitem.id)).distance; // border to dest
			dprintln("distance between " + sourceitem.id + " and " + destitem.id + " set to " + newdistance, 16);
			dprintln("updating distance between " + sourceitem.id + " and " + destitem.id + " set to " + newdistance, 16);
			// If this change didnt make things closer, leave the old distance in the metric
			if(newdistance < compdist.distance)
				dist.distance = newdistance;
			else
				dist.distance = compdist.distance;
			dprintln("final distance between " + sourceitem.id + " and " + destitem.id + " set to " + dist.distance, 16);
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/6/99 10:59:44 AM)
 */
public void recalcMinDistance(Component collapse, int removeid) {
	Component tempc1, tempc2; // The two components we are going to compare

	TaxaItem tempt1, tempt2; // The two taxa we are going to compare
	Distance mindist = new Distance();
	Distance nextdist;
	Enumeration enumall, enumtaxa, enumcollapse;

	// first change all of the other clusters that used to have the removed cluster as their min, 
	//  to now have the collapsed version as their min.

	enumall = components.elements();
	while (enumall.hasMoreElements()) {
		tempc1 = (Component) enumall.nextElement();
		if (tempc1.mindist.dc.id == removeid) {
			tempc1.mindist.dc = collapse;
		}
	}
	mindist.distance = BIGNUM;

	// Now we need to find the min distance for this cluster.
	// Search through all of the other clusters for the taxa that has the min distance from here

	enumall = components.elements();
	// For each of the other clusters
	while (enumall.hasMoreElements()) {
		tempc1 = (Component) enumall.nextElement();
		if (tempc1 == collapse) {
			continue;
		}
		enumtaxa = tempc1.taxa.elements();
		// For each of the real taxa in this cluster
		while (enumtaxa.hasMoreElements()) {
			tempt1 = (TaxaItem) enumtaxa.nextElement();
			if (tempt1.isIntermediate)
				continue;
			enumcollapse = collapse.taxa.elements();
			// Compare with everything in collapse to find the minimum
			while (enumcollapse.hasMoreElements()) {
				tempt2 = (TaxaItem) enumcollapse.nextElement();
				if (tempt2.isIntermediate)
					continue;
				nextdist = (Distance) tempt2.realdist.elementAt(tempt1.id);
				if (nextdist.distance < mindist.distance) {
					mindist.clone(nextdist);
					mindist.sc = collapse;
					mindist.dc = tempc1;
					dprintln("min distance for " + collapse.id + 
						" = " + mindist.distance + " from " + mindist.source +
						" to " + mindist.destination+" in "+tempc1.id,0x100);
				}
			}
		}
	}
	dprintln("recalc cluster min distance for " + collapse.id + " = " + mindist.distance + " from " + mindist.source + " to " + mindist.destination,0x100);
	collapse.mindist = mindist;
}
/**
 * Unmark all of the metric distances so they will not be finalized later
 * Creation date: (11/3/99 11:06:44 PM)
 * @param source Component
 * @param dest Component
 */
public void RemoveAllMetrics(Component source, Component dest) {
	Enumeration enumt;
	TaxaItem item;

	// First do the source cluster
	enumt = source.taxa.elements();
	while (enumt.hasMoreElements()) {
		item = (TaxaItem)enumt.nextElement();
		item.newconnections.removeAllElements();
	}
	// Now do the destination cluster
	enumt = dest.taxa.elements();
	while (enumt.hasMoreElements()) {
		item = (TaxaItem)enumt.nextElement();
		item.newconnections.removeAllElements();
	}
}
}


