package byu;

/****************************************************************************
** COPYRIGHT (C):    1996 Cay S. Horstmann. All Rights Reserved.
** PROJECT:          Computing Concepts with Java
** FILE:             GraphicsApplet.java
****************************************************************************/

/**
 * A class for drawing simple graphics
 * @version 1.00 11 Apr 1997
 * @author Cay Horstmann
 * @author Quinn Snell (BYU)
 */

import java.awt.event.*;

class GraphicsCanvas extends java.awt.Canvas
{     static java.util.Vector shapes;
public GraphicsCanvas()
   {  shapes = new java.util.Vector();
   }   
   public void addShape(Shape s)
   {  //shapes.addElement(s.clone());
	  shapes.addElement(s);
	  s.redraw(getGraphics(), ((GraphicsApplet)getParent()).getCoord());
   }   
   public void erase(Shape s)
   {
	  java.awt.Graphics g = getGraphics();
	  java.awt.Color current = g.getColor();
	  g.setColor(getBackground());
	  s.redraw(g, ((GraphicsApplet)getParent()).getCoord());
	  g.setColor(current);
   }   
   public void paint(java.awt.Graphics g)
   {  for (int i = 0; i < shapes.size(); i++)
		 ((Shape)shapes.elementAt(i)).redraw(g, ((GraphicsApplet)getParent()).getCoord() );
   }   
   public void setBounds(int x, int y, int w, int h)
   {  int s = Math.min(w, h);
	  x += (w - s) / 2;
	  y += (h - s) / 2;
	  super.setBounds(x, y, s, s);
   }   
}
